"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importStar(require("react"));
require("azure-maps-drawing-tools/dist/atlas-drawing.min.css");
var azure_maps_drawing_tools_1 = require("azure-maps-drawing-tools");
var AzureMapContext_1 = require("./AzureMapContext");
var useCheckRef_1 = require("../hooks/useCheckRef");
var AzureMapDrawingManagerContext = react_1.createContext({
    drawingManagerRef: null
});
exports.AzureMapDrawingManagerContext = AzureMapDrawingManagerContext;
var DrawingManagerProvider = AzureMapDrawingManagerContext.Provider, AzureMapDrawingManagerConsumer = AzureMapDrawingManagerContext.Consumer;
exports.AzureMapDrawingManagerConsumer = AzureMapDrawingManagerConsumer;
var AzureMapDrawingManagerStatefulProvider = function (_a) {
    var options = _a.options, children = _a.children;
    var mapRef = react_1.useContext(AzureMapContext_1.AzureMapsContext).mapRef;
    var _b = react_1.useState(null), drawingManagerRef = _b[0], setDrawingManagerRef = _b[1];
    useCheckRef_1.useCheckRefMount(mapRef, true, function (mref) {
        var drawingManager = new azure_maps_drawing_tools_1.drawing.DrawingManager(mref);
        drawingManager.setOptions(options);
        setDrawingManagerRef(drawingManager);
    });
    react_1.useEffect(function () {
        if (drawingManagerRef && options) {
            drawingManagerRef.setOptions(options);
        }
    }, [options]);
    return (react_1.default.createElement(DrawingManagerProvider, { value: {
            drawingManagerRef: drawingManagerRef
        } }));
};
exports.AzureMapDrawingManagerProvider = AzureMapDrawingManagerStatefulProvider;
//# sourceMappingURL=AzureMapDrawingManagerContext.js.map